/*
 * Copyright 2009 Nicolas LE GRIEL.
 * 
 * Les sources qui constituent ce projet nlegriel-dvp-defi5 de mme que 
 * la documentation associe sont la proprit de leur auteur.
 * 
 * Je donne mon accord au site developpez.com pour l'utilisation de 
 * tout ou partie des sources et de la documentation de ce projet dans 
 * les pages developpez.com
 */
package com.developpez.nlegriel.defi5;

/**
 * Ensemble des pices du cube de Soma.
 *
 * @author Nicolas LE GRIEL
 */
public enum PuzzlePart {
	A(PuzzlePartPositionsProvider.getPositionsOfPart(new Cube[] {
			new Cube(0, 0, 0),
			new Cube(1, 0, 0),
			new Cube(0, 0, 1),
			new Cube(0, 1, 1)
	})),
	
	B(PuzzlePartPositionsProvider.getPositionsOfPart(new Cube[] {
			new Cube(0, 0, 0),
			new Cube(0, 1, 0),
			new Cube(0, 0, 1),
			new Cube(1, 0, 1)
	})),
	
	P(PuzzlePartPositionsProvider.getPositionsOfPart(new Cube[] {
			new Cube(0, 0, 0),
			new Cube(1, 0, 0),
			new Cube(0, 1, 0),
			new Cube(0, 0, 1)
	})),
	
	Z(PuzzlePartPositionsProvider.getPositionsOfPart(new Cube[] {
			new Cube(0, 0, 0),
			new Cube(0, 1, 0),
			new Cube(1, 1, 0),
			new Cube(1, 2, 0)
	})),
	
	T(PuzzlePartPositionsProvider.getPositionsOfPart(new Cube[] {
			new Cube(0, 0, 0),
			new Cube(1, 0, 0),
			new Cube(1, 1, 0),
			new Cube(2, 0, 0)
	})),
	
	L(PuzzlePartPositionsProvider.getPositionsOfPart(new Cube[] {
			new Cube(0, 0, 0),
			new Cube(1, 0, 0),
			new Cube(2, 0, 0),
			new Cube(2, 1, 0)
	})),
	
	V(PuzzlePartPositionsProvider.getPositionsOfPart(new Cube[] {
			new Cube(0, 0, 0),
			new Cube(1, 0, 0),
			new Cube(0, 1, 0)
	}));
	
	private Cube[][] positions;
	
	/**
	 * Permet d'associer  une pice du puzzle toutes ses positions possibles
	 * avec un moins un cube passant les coordonnes (0, 0, 0).
	 * 
	 * @param positions contient toutes les positions possibles pour la
	 * pice
	 */
	private PuzzlePart(Cube[][] positions) {
		this.positions = positions;
	}

	public Cube[][] getPositions() {
		return positions;
	}
}
